//+------------------------------------------------------------------+
//|                                        wpr + bollinger bands.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  DarkOrange
#property indicator_color4  Orange
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_width1  3
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Magenta

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    AtrPeriod        = 50;
extern int    Price            = PRICE_CLOSE;
extern int    BandsPeriod      = 50;
extern double BandsDeviations  = 2; 
extern bool   Interpolate      = true;

extern string  __              = "arrows settings";
extern bool   ShowArrows       = false; 
extern string ArrowsIdentifier = "atrba";
extern color  ArrowUpColor     = LimeGreen;
extern int    ArrowUpWidth     = 2;
extern color  ArrowDownColor   = Red; 
extern int    ArrowDownWidth   = 2; 


extern string  _               = "alerts settings";
extern bool    alertsOn        = true;
extern bool    alertsOnCurrent = true;
extern bool    alertsMessage   = true;
extern bool    alertsSound     = false;
extern bool    alertsEmail     = false;

//
//
//
//
//

double atr[];
double bandsUp[];
double bandsMi[];
double bandsDo[];
double trend[];
double atrend[];
double TempBuffer[];

string IndicatorFileName;
bool   Calculatingatr;
bool   ReturningBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,atr);
   SetIndexBuffer(1,bandsUp);
   SetIndexBuffer(2,bandsMi);
   SetIndexBuffer(3,bandsDo);
   SetIndexBuffer(4,trend);
   SetIndexBuffer(5,atrend);
   SetIndexBuffer(6,TempBuffer);
   
   

   //
   //
   //
   //
   //
   
      IndicatorFileName   = WindowExpertName();
      Calculatingatr      = (TimeFrame=="Calculatingatr"); if (Calculatingatr) return(0);
      ReturningBars       = (TimeFrame=="returnBars");   if (ReturningBars)  return(0);
      timeFrame           = stringToTimeFrame(TimeFrame);
         
   //
   //
   //
   //
   //
               
   IndicatorShortName(" non lag atr with bands "+timeFrameToString(timeFrame)+" ("+AtrPeriod+","+BandsPeriod+","+DoubleToStr(BandsDeviations,2)+")");
   return(0);
}

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
   }
   return(0);
}




int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ReturningBars)  { atr[0] = limit+1; return(0); }

   
   
      if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (Calculatingatr || timeFrame==Period())
      {
      for(i=limit; i >= 0; i--)
      {    
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer[i]=high-low;
      else
      {
      double prevclose=Close[i+1];
      TempBuffer[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
      }
      atr[i] = iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i),AtrPeriod,i,0);
      }
      for(i=limit; i>=0; i--) 
      {
      double deviations = iStdDevOnArray(atr,0,BandsPeriod,0,MODE_LWMA,i);
      bandsMi[i] = iMAOnArray(atr,0,BandsPeriod,0,MODE_LWMA,i);
      bandsUp[i] = bandsMi[i]+deviations*BandsDeviations;
      bandsDo[i] = bandsMi[i]-deviations*BandsDeviations;
      
      trend[i] = trend[i+1];
      if (atr[i] < bandsDo[i] && atr[i+1] >= bandsDo[i+1] ) trend[i] =  1;
      if (atr[i] > bandsUp[i] && atr[i+1] <= bandsUp[i+1] ) trend[i] = -1;  
      manageArrow(i);  
     }
     manageAlerts();
     return(0);
   }

   

      for(i=limit; i>=0; i--)
      {
            int y         = iBarShift(NULL,timeFrame,Time[i]);
            atr[i]        = iCustom(NULL,timeFrame,IndicatorFileName,"Calculatingatr",AtrPeriod,Price,BandsPeriod,BandsDeviations,0,y);
            bandsUp[i]    = iCustom(NULL,timeFrame,IndicatorFileName,"Calculatingatr",AtrPeriod,Price,BandsPeriod,BandsDeviations,1,y);
            bandsMi[i]    = iCustom(NULL,timeFrame,IndicatorFileName,"Calculatingatr",AtrPeriod,Price,BandsPeriod,BandsDeviations,2,y);
            bandsDo[i]    = iCustom(NULL,timeFrame,IndicatorFileName,"Calculatingatr",AtrPeriod,Price,BandsPeriod,BandsDeviations,3,y);
            trend[i]      = iCustom(NULL,timeFrame,IndicatorFileName,"Calculatingatr",AtrPeriod,Price,BandsPeriod,BandsDeviations,4,y);
            TempBuffer[i] = iCustom(NULL,timeFrame,IndicatorFileName,"Calculatingatr",AtrPeriod,Price,BandsPeriod,BandsDeviations,6,y);
            
            manageArrow(i);
         
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         

         datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         double factor = 1.0 / n;
         for(int j = 1; j < n; j++)
         {
  	      atr[i+j]         = j*factor*atr[i+n]         + (1.0-j*factor)*atr[i];
  	      bandsUp[i+j]     = j*factor*bandsUp[i+n]     + (1.0-j*factor)*bandsUp[i];
  	      bandsMi[i+j]     = j*factor*bandsMi[i+n]     + (1.0-j*factor)*bandsMi[i];
  	      bandsDo[i+j]     = j*factor*bandsDo[i+n]     + (1.0-j*factor)*bandsDo[i];
  	      bandsDo[i+j]     = j*factor*bandsDo[i+n]     + (1.0-j*factor)*bandsDo[i];
  	      TempBuffer[i+j]  = j*factor*TempBuffer[i+n]  + (1.0-j*factor)*TempBuffer[i];
        }  	            
   }
      
   
   manageAlerts();   
   return(0);
}



string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

void manageArrow(int i)
{
   if (ShowArrows && !Calculatingatr)
   {
      double dist = iATR(NULL,0,20,i)/2.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      atrend[i] = atrend[i+1];
         if (atr[i] < bandsDo[i] && atr[i+1] >= bandsDo[i+1] ) atrend[i] = -1;
         if (atr[i] > bandsUp[i] && atr[i+1] <= bandsUp[i+1] ) atrend[i] =  1;
         if (atrend[i] !=atrend[i+1])
         {
            string name = ArrowsIdentifier+Time[i];
            if (atrend[i] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,241);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
                  ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth);
            }
            else
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,242);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
                  ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth);
            }
         }
   }
}



void manageAlerts()
{
   if (!Calculatingatr && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Ergodic cci trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ergodic cci "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}




#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

double  nlmvalues[][3];
double  nlmprices[][1];
double  nlmalphas[][1];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   if (ArrayRange(nlmprices,0) != Bars)         ArrayResize(nlmprices,Bars); r=Bars-r-1;
   if (ArrayRange(nlmvalues,0) <  instanceNo+1) ArrayResize(nlmvalues,instanceNo+1);
                               nlmprices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlmprices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = (int)(length-1);
      
         nlmvalues[instanceNo][_length] = length;
         nlmvalues[instanceNo][_len   ] = length*4 + Phase;  
         nlmvalues[instanceNo][_weight] = 0;

         if (ArrayRange(nlmalphas,0) < nlmvalues[instanceNo][_len]) ArrayResize(nlmalphas,(int)nlmvalues[instanceNo][_len]);
         for (int k=0; k<nlmvalues[instanceNo][_len]; k++)
         {
            double t = 0;
            if (k<=Phase-1) 
                 t = 1.0 * k/(Phase-1);
            else t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlmalphas[k][instanceNo]        = g * beta;
            nlmvalues[instanceNo][_weight] += nlmalphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_weight]>0)
   {
      double sum = 0;
           for (k=0; k < nlmvalues[instanceNo][_len] && (r-k)>=0; k++) sum += nlmalphas[k][instanceNo]*nlmprices[r-k][instanceNo];
           return( sum / nlmvalues[instanceNo][_weight]);
   }
   else return(0);           
}